%% Formation analyse de series organisee par Ingrid Puillat et Dhouha Kbaier
% Lieu: Ifremer, Brest, France
% Dates: Mercredi 27 et Jeudi 28 Mai 2015 (Session1); puis Mercredi 3 et Jeudi 4 Juin 2015 (Session 2)
% Auteur: Dhouha Kbaier Ben Ismail
% e-mail: dhouha.kbaier@ifremer.fr
%%
clear all;
close all;

global x_data;
global y_data;
global ts;
global msg;
global titre;
global yLabel;
global xLabel;

%% Tlcharger vos donnes ici (remplacer le code pour les 6 lignes suivantes)
% load ('Pascal_TS.mat');
% x_data=date;
% y_data=ti(:,1);
% xLabel='Time (year, month, day, hour)';
% yLabel='Temperature (C)';
% titre='Temperature in the Reunion island from 21/07/2011 12h00 to 19/01/2012 00h00';
% 
% 
% load('resume_ADCP_total_rotation.mat')
% x_data=ADCP(4).date;
% y_data=ADCP(4).u(:,2);
% xLabel='Time (year, month, day, hour)';
% yLabel='cm/s';
% titre='Along-shore currents in the Reunion island at station S4';

load('load_donnes_Marel.mat')
time1=timeTemp;time2=timeSali;time3=timeSeaLevel;time4=timeTurbi;
data1=Temp;data2=Sali;data3=SeaLevel;data4=Turbi;
x_data=time4;
y_data=data4;
xLabel='Time (year, month, day, hour)';
yLabel='Turbidity (NTU)';
titre='Turbidity (Marel Carnot) over 5 years from 2005 to 2009';

%% plot time series
ts=timeseries(y_data,x_data);
msg='';

%% On peut utiliser Time series tool
% tstool(ts);

%% Plot time series
figure
s(1) = subplot(2,1,1);
plot(ts,'+:r');
tlabel;
xlim([x_data(1) x_data(end)]);
xlabel(xLabel);
ylabel(yLabel);
title(titre,'FontWeight','bold');



 %% plot histogram
s(2) = subplot(2,1,2);
% figure
partitions = ceil(sqrt(length(y_data))/2);
hist(y_data,partitions,'bar');
title('Histogram','FontWeight','bold')

%Change histogram color properties:
%Get the handle to the patch object that creates the histogram bar plot.
h = findobj(gca,'Type','patch');
%Use the handle to change the face color and the edge color of the bars plotted.
set(h,'FaceColor','w','EdgeColor','b');

%Statistics
mean_y=mean(y_data(~isnan(y_data))); % c'est l'equivalent de mean_y=nanmean(y_data)
mode_y=mode(y_data(~isnan(y_data)));
median_y=median(y_data(~isnan(y_data)));
skew=skewness(y_data(~isnan(y_data)));
if(skew >0)
    msg=['Positive skew (= ' num2str(skew) '):'];
    msg=char(msg,'we check that mean > median > mode ');
    if(mean_y>median_y && median_y >mode_y)  
      msg=char(msg,'--> succesfull check');
    else  
        msg=char(msg,'--> check failure');
    end
else %skew <0
    msg=char(msg,['Negative skew (= ' num2str(skew) '):']);
    msg=char(msg,'we check that mean < median < mode');
    if(mean_y<median_y && median_y <mode_y)     
        msg=char(msg,'--> succesfull check');
    else
         msg=char(msg,'--> check failure');
    end 
end


%% Tests whether the values are monotonically increasing
% all(diff(y)>0)

%% Tests for equally spaced elements (x axis)
hms=datevec(x_data);% year month day hour minute second conversion
dateDiff=datevec(diff(diff(date)));
vectDiff=datenum(dateDiff);
if (all(vectDiff==0)==1)
     msg=char(msg,'Equally spaced data');
else
     msg=char(msg,'Unequally spaced data');
end


%% Search gap in the time series (y axis)
search=find(isnan(y_data)); %a list of NaN element indicies
if (isempty(search))
%     disp('No gap (NaN) in the time series');
    msg=char(msg,'No gap (NaN) in the time series');
else
%     disp('Detected NaN for',search);
%     msg=char(msg,'Detected NaN for',search);
      msg=char(msg,'Detected NaN');
end


% Afficher le message sur l'histogramme?
a = axis;
wdth = a(2)-a(1);
ht = a(4)-a(3);
% Please change the parameters 0.65 & 0.4 to your convenience
pos = [a(1)+0.65*wdth a(4)-0.4*ht];
text(pos(1),pos(2),msg,'FontSize',12,'FontName','arial','FontWeight','demi','color','k');








