%% Formation analyse de series organisee par Ingrid Puillat et Dhouha Kbaier
% Lieu: Ifremer, Brest, France
% Dates: Mercredi 27 et Jeudi 28 Mai 2015 (Session1); puis Mercredi 3 et Jeudi 4 Juin 2015 (Session 2)
% Auteur: Dhouha Kbaier Ben Ismail
% e-mail: dhouha.kbaier@ifremer.fr

%%
clear all;
close all;


global x_data;
global y_data;
global ts;
global Fs;% sampling frequency 10 minutes= 600 seconds
global L; % Length of signal
global phi; % angle to compute the inertial wave

%% Spectral analysis 
% load ('Pascal_TS.mat');
% x_data=date;
% y_data=ti(:,1);

%% Tlcharger vos donnes et modifier deltat !!!

load('load_donnes_Marel.mat')
time1=timeTemp;time2=timeSali;time3=timeSeaLevel;time4=timeTurbi;
data1=Temp;data2=Sali;data3=SeaLevel;data4=Turbi;
x_data=time3;
y_data=fixgaps(data3);


% load('resume_ADCP_total_rotation.mat')
% x_data=ADCP(1).date;
% y_data=ADCP(1).u(:,2);


% load maree_conquet;
% x_data=(date2(1): 1/(60*24):date2(end))';
% interpolation=interp1(date2,xe,x_data) ;
% y_data=interpolation-nanmean(xe) ;

ts=timeseries(y_data,x_data);
% deltat   =mean(diff(x_data));
deltat   =20/(24*60); % 10 min pour les donnes ile de la Runion et 20 min pour Marel Carnot


Fs=1/deltat;
L = length(y_data);% Length of signal

%% Quelques donnees sur les ondes principales (periodes en cycle/jour)
pM2=12.42 ;cpdM2=24/pM2;
pS2=12.   ;cpdS2=24/pS2;
pO1=25.82 ;cpdO1=24/pO1;
pK1=23.93 ;cpdK1=24/pK1;

% calcul de f
om=2*pi/86400;
phi=21; % ile de la Reunion
% phi=47; % Brest
w_rot=2*om*sind(phi);
freqInertie=w_rot/(2*pi);
pIn=2*pi/w_rot/3600; cpdIn=24/pIn;

%% Modified Periodogram using Hamming
freq = 0:L-1; %Numerators of frequency series
freq = freq.*Fs./L;
% Obtain the periodogram with 95%-confidence bounds.
% When a frequency vector is specified, a 'twosided' PSD is computed
% [Pxx,F,Pxxc] = periodogram(y_data,hamming(L),freq,Fs,'ConfidenceLevel', 0.95);

[Pxx,F,Pxxc] = periodogram(y_data,hamming(L),[],Fs,'ConfidenceLevel', 0.95);
% [Pxx,F] = periodogram(y_data,hamming(L),[],Fs);

% The average power can be computed by approximating the integral with the following sum:
averPow = (Fs/length(Pxx)) * sum(Pxx);
%We can also compute the average power from the one-sided PSD estimate:
% averPow = (Fs/(2*length(Pxx))) * sum(Pxx);
figure;
plot(F,10*log10(Pxx));
% hold on;
% plot(F,10*log10(Pxxc),'r--','linewidth',2);


xlabel('Cycles/day'); ylabel('dB');
grid on;
title('Modified Periodogram','FontWeight','bold');

smin=-80;smax=120; % parametres a modifier en fonction du periodogramme

hold on;
plot([cpdM2 cpdM2],[smin smax],'-.k')
text( cpdM2,0.8*smax,'$$M2$$','interpreter','latex','fontsize',10)

hold on;
plot([cpdK1 cpdK1],[smin smax],'-.k')
text( cpdK1,0.5*smax,'$$K1$$','interpreter','latex','fontsize',10)
hold on;
plot([cpdIn cpdIn],[smin smax],'-.k')
text( cpdIn,0.8*smax,'$$In$$','interpreter','latex','fontsize',10)


%% Another method --> Periodogram Using FFT
ydft = fft(y_data);
ydft = ydft(1:fix(L./2)+1);
psdy = (1/(Fs*L)).*abs(ydft).^2;
psdy(2:end-1) = 2*psdy(2:end-1);
freq2 = 0:Fs/L:Fs/2;
figure;
plot(freq2,10*log10(psdy)); grid on;
title('Periodogram Using FFT','FontWeight','bold');
xlabel('Frequency (cycles per day)'); ylabel('Power/Frequency (dB)');

% % smin=-80;smax=120; % parametres a modifier en fonction du periodogramme
% % 
% % hold on;
% % plot([cpdM2 cpdM2],[smin smax],'-.r')
% % text( cpdM2,0.8*smax,'$$M2$$','interpreter','latex','fontsize',10,'Color','r')
% % 
% % hold on;
% % plot([cpdK1 cpdK1],[smin smax],'-.m')
% % text( cpdK1,0.5*smax,'$$K1$$','interpreter','latex','fontsize',10,'Color','m')
% % hold on;
% % plot([cpdIn cpdIn],[smin smax],'-.k')
% % text( cpdIn,0.8*smax,'$$In$$','interpreter','latex','fontsize',10)

%% Another method --> using pwelch 
na = 16;% Calculate an 16-times averaged spectrum with pwelch
w = hanning(floor(L/na));
%[Pxx,F] = pwelch(X,WINDOW,NOVERLAP,F,Fs);
% [pxw,f,pxc] = pwelch(y_data,w,0,[],Fs,'ConfidenceLevel',0.95);
[pxw,f] = pwelch(y_data,w,0,[],Fs);
figure; 
plot(f,10*log10(pxw));
% hold on;
% plot(f,10*log10(pxc),'r--','linewidth',2);
grid on;
title('Power spectrum generated with pwelch (with 95%-Confidence Bounds)','FontWeight','bold');
xlabel('cycles per day'); ylabel('dB');
% Calculate the spectrum parameters
fbin = f(2)-f(1);
CG = sum(w)/(L/na);
NG = sum(w.^2)/(L/na);



%% Faire comme pwelch mais sans la commande pwelch
freedom=10;
N       = length(y_data);
nfft    = fix(N./freedom);         % max number of Fourier components
if mod(nfft,2)==1                  % if nfft is an odd number
    nfft=nfft-1;
end
overlap = 1/2;                     % fraction de la longueur du segment pour l'overlap entre les segments
segment = freedom/overlap-1 ;      % nombre de segment sur lesquel on fera la fft 

% deltat   = mean(diff(x_data));  
% Fs       = 1./deltat;              % sampling frequency in seconds^-1
df       = Fs/nfft;                % Frequential resolution 

% dcoupage de la srie temporelle en segments 
A                           = zeros(nfft,segment);
A(1:nfft,1:freedom)         = reshape(y_data(1:nfft*freedom),[nfft,freedom]);
A(1:nfft,freedom+1:segment) = reshape(y_data(1+nfft*overlap:nfft*overlap+nfft*(freedom-1)),[nfft,freedom-1]);

% fenetre pour la fft (supprime les effets de bords)           
hanning = transpose(0.5 * (1-cos(2*pi*linspace(0,nfft-1,nfft)/(nfft-1))));
E=ones(1,segment);
H=hanning*E;
wc2=1/mean(hanning.^2);            % window correction factor
                           
A2=H.*detrend(A,'constant');            % anomalie du signal A2=A-mean(A)
pspec=mean(abs(fft(A2,nfft,1)).^2,2);
pspec=pspec./nfft^2/df;
spec=pspec*wc2;       % spectrum where variance is sum(spec)*df

  
coef = (deltat*nfft);               % dure d'un segment 
freqPascal = [0:floor(nfft/2)-1 0 -floor(nfft/2)+1:-1]' / coef;

oneside=spec(1:nfft/2);
oneside(2:nfft/2)=2*spec(2:nfft/2);

scrsz = get(0,'ScreenSize');
figure('Position',[10 50 500 300]);clf;hold on
set(0,'DefaultFigurePaperPositionMode','auto')

hh= plot(freqPascal(1:nfft/2),oneside,'color','k','linewidth',2);

set(gca,'Xscale','log','Yscale','log')
xlabel('frequency (cpd)','fontsize',12)
ylabel('PSD (/cpd)','fontsize',12)
title('Spectrum','interpreter','latex','fontsize',14)
grid on
