%% Formation analyse de series organisee par Ingrid Puillat et Dhouha Kbaier
% Lieu: Ifremer, Brest, France
% Dates: Mercredi 27 et Jeudi 28 Mai 2015 (Session1); puis Mercredi 3 et Jeudi 4 Juin 2015 (Session 2)
% Auteur: Dhouha Kbaier Ben Ismail
% e-mail: dhouha.kbaier@ifremer.fr

%%
clear all;
close all;

global x_data;
global y_data;


%% Telecharger vos donnes

% load('resume_ADCP_total_rotation.mat')
% x_data=ADCP(4).date;
% y_data=ADCP(4).u(:,2);

load('Pascal_TS.mat');
x_data=date;
y_data=ti(:,1);

% load('load_donnes_Marel.mat')
% time1=timeTemp;time2=timeSali;time3=timeSeaLevel;time4=timeTurbi;
% data1=Temp;data2=Sali;data3=SeaLevel;data4=Turbi;
% x_data=time4(~isnan(data4));
% y_data=data4(~isnan(data4));

%% L algorithme est adapte  des donnees manquantes. On peut avoir un axe de temps irregulier
x_data=x_data(~isnan(y_data));
y_data=y_data(~isnan(y_data));

%% Supprimer volontairement d autres donnes pour tester les limites de l algorithme LombScargle

% % Keep random time points, discard the rest
% % Note: To increase the number of points retained, decrease the multiplier (and vice versa)
% discpct = 49; %Percent of data points to discard: 2% (1 week)   8%(1 month) 25% (3 months) 33%(4 months) 50%( 6 months)
% ndiscards = floor((discpct/100)*length(x_data));
% keeps = randperm(length(x_data));
% keeps = sort(keeps(ndiscards+1:end)); %Discard 30% of the samples, selected randomly
% x_data=x_data(keeps);
% y_data=y_data(keeps);

%% Lomb-Scargle Powerspectrum
inputdata=[x_data y_data];
tic
[freqsLombscargle, sigfreqs,expytable ,effm]=lombscargle(inputdata);
toc

figure
loglog(freqsLombscargle(:,1),freqsLombscargle(:,2),'color','b');
alph=0.05;
lineat=log(1./(1-(1-alph).^(1/effm)));
fhi=75;
line([freqsLombscargle(1,1),30],[lineat,lineat],'color','black','linewidth',4/5,'linestyle','-.');
text(20,lineat,'95%','fontsize',10,'fontname','s');
xlim([log(freqsLombscargle(1,1)) 30]);

pSa=365.24; cpdSa=1/pSa; % annuelle
pSsa=182.62; cpdSsa=1/pSsa; %semi annuelle
pMm=27.55; cpdMm=1/pMm; %mensuelle
pMsf=14.76;cpdMsf=1/pMsf;% bi-mensuelle
pM2=12.42 ;cpdM2=24/pM2;
pS2=12.   ;cpdS2=24/pS2;
pO1=25.82 ;cpdO1=24/pO1;
pK1=23.93 ;cpdK1=24/pK1;

% calcul de f
om=2*pi/86400;
phi=21; % ile de la Reunion
% phi=47; % Brest
w_rot=2*om*sind(phi);
freqInertie=w_rot/(2*pi);
pIn=2*pi/w_rot/3600; cpdIn=24/pIn;

smin=10^0;smax=3*10^3; 
hold on;
plot([cpdSa cpdSa],[smin smax],'-.r', 'linewidth',2) 
text(cpdSa,smax,'$$Sa$$','interpreter','latex','fontsize',10) 

hold on;
plot([cpdMm cpdMm],[smin smax],'-.g', 'linewidth',2) 
text(cpdMm,smax,'$$Mm$$','interpreter','latex','fontsize',10) 

hold on;
plot([cpdMsf cpdMsf],[smin smax],'-.k', 'linewidth',2) 
text(cpdMsf,smax,'$$Msf$$','interpreter','latex','fontsize',10) 

smin=10^-4;smax=10^3; 
hold on;
plot([cpdM2 cpdM2],[smin smax],'-.r', 'linewidth',2) 
text(cpdM2,smax,'$$M2$$','interpreter','latex','fontsize',10) 

hold on;
plot([cpdK1 cpdK1],[smin smax],'-.k', 'linewidth',2) 
text(cpdK1,smax,'$$K1$$','interpreter','latex','fontsize',10) 

hold on;
plot([2*cpdM2 2*cpdM2],[smin smax],'-.g', 'linewidth',2) 
text(2*cpdM2,smax,'$$M4$$','interpreter','latex','fontsize',10) 


hold on;
plot([cpdIn cpdIn],[smin smax],'-.r', 'linewidth',2) 
text(cpdIn,smax,'$$In$$','interpreter','latex','fontsize',10) 

xlim([log(freqsLombscargle(1,1)) 30]);