%% Formation analyse de series organisee par Ingrid Puillat et Dhouha Kbaier
% Lieu: Ifremer, Brest, France
% Dates: Mercredi 27 et Jeudi 28 Mai 2015 (Session1); puis Mercredi 3 et Jeudi 4 Juin 2015 (Session 2)
% Auteur: Dhouha Kbaier Ben Ismail
% e-mail: dhouha.kbaier@ifremer.fr

%%
close all;
clear all;
global time_data;
global series_data;
global dt;

%% Telecharger vos donnes ici SANS INTERPOLATION et changer dt

% load('resume_ADCP_total_rotation.mat')
% for i=1:length(ADCP)
%     time_data(i,:)=ADCP(1).date;
%     series_data(i,:)=ADCP(i).u(:,2);
% end
% 
% % % dt=mean(diff(time_data)); % 10 min
% % dt=10/60;

load ('pascal_TS.mat');
for i=1:size(ti,2)
    time_data(i,:)=date;
    series_data(i,:)=ti(:,i);
end

dt=10/60; % toutes les 10 minutes


% load('load_donnes_Marel.mat')
% 
% time1=timeTemp;time2=timeSali;time3=timeSeaLevel;time4=timeTurbi;
% data1=Temp;data2=Sali;data3=SeaLevel;data4=Turbi;
% time_data(1,:)=time1;time_data(2,:)=time2;time_data(3,:)=time3;time_data(4,:)=time3;
% series_data(1,:)=data1;series_data(2,:)=data2;series_data(3,:)=data3;series_data(4,:)=data4;
% 
% dt=20/60; % toutes les 20 minutes

%% Preparer les donnes: pas d interpolation et pas de NaN, juste les instants auxquels les donnes ont bien ete mesurees

%% EMD 
[imf1,ort1,nbits1] = emd(series_data(1,~isnan(series_data(1,:)))','T',time_data(1,~isnan(series_data(1,:))),'MAXITERATIONS',600);
[imf2,ort2,nbits2] = emd(series_data(2,~isnan(series_data(2,:)))','T',time_data(2,~isnan(series_data(2,:))),'MAXITERATIONS',600);
[imf3,ort3,nbits3] = emd(series_data(3,~isnan(series_data(3,:)))','T',time_data(3,~isnan(series_data(3,:))),'MAXITERATIONS',600);
[imf4,ort4,nbits4] = emd(series_data(4,~isnan(series_data(4,:)))','T',time_data(4,~isnan(series_data(4,:))),'MAXITERATIONS',2000);

%% Calculation of mean instantaneous period of each IMF

meanPeriod(1,1:size(imf1,1)-1)=mean(diff(time_data(1,:)))*(1./meanf(imf1));
meanPeriod(2,1:size(imf2,1)-1)=mean(diff(time_data(2,:)))*(1./meanf(imf2));
meanPeriod(3,1:size(imf3,1)-1)=mean(diff(time_data(3,:)))*(1./meanf(imf3));
meanPeriod(4,1:size(imf4,1)-1)=mean(diff(time_data(4,:)))*(1./meanf(imf4));


%% Cross correlation globale entre les deux series d origine
time1=time_data(1,:); % changer cette ligne
time2=time_data(2,:); % changer cette ligne
data1=series_data(1,:); % changer cette ligne
data2=series_data(2,:); % changer cette ligne
% seriesname={'u(S1)' 'u(S2)' 'u(S3)' 'u(S4)'};
 seriesname={'Temp1' 'Temp2'}; % changer cette ligne
 
 % s'il y a des NaN, ne pas les considerer et interpoler les donnes sur le
 % meme axe de temps
 
 
% Normalising the data 
data1=(data1-mean(data1))/std(data1);
data2=(data2-mean(data2))/std(data2);
[acor,lags] = xcorr(data1,data2,'coeff'); 
[maxCorr,I] = max(abs(acor));
tau = lags(I); % data 2 leads data 1 by tau samples

figure,

subplot(411); plot(time1, data1); tlabel; xlim([time1(1) time1(end)]);
title(seriesname(1),'fontweight', 'bold'); 

subplot(412); plot(time2, data2); tlabel; xlim([time2(1) time2(end)]);
title(seriesname(2),'fontweight', 'bold'); 

subplot(413); plot(lags,acor); 
xlabel('lag index','fontweight', 'bold');
title(['Cross-correlation between ' seriesname(1) ' and ' seriesname(2)],'fontweight', 'bold')

subplot(414); 
dt=10/60; % 10 min  transformer en heures
plot(lags*dt,acor); 
grid on;
xlabel('Time lag (hours)','FontSize',10,'fontweight', 'bold')
title('Zoom (Cross-correlation)','fontweight', 'bold')

smin=min(abs(acor));
smax=maxCorr+0.01;
hold on; plot([tau*dt tau*dt],[smin smax],'-.r','Linewidth',2)
xlim([-10 10 ]);
text(tau *dt,maxCorr,[' \leftarrow (',num2str(tau*dt*60),' min, ', num2str(maxCorr),')'],'FontSize',10,'fontweight', 'bold','Color','r')


%% Maintenant on va choisir des IMFs pour faire la cross correlation
% Pour cela, on choisit des IMFs ayant des periodes moyennes proches
% On fait une figure qui nous permet de mieux les visualiser

figure
semilogy(1:1:size(imf1,1)-1,meanPeriod(1,1:size(imf1,1)-1),'*b')
hold on
semilogy(1:1:size(imf2,1)-1,meanPeriod(2,1:size(imf2,1)-1),'+r')

tttttt=0:1:size(imf1,1)-1;
% alpha et gamma --> Parametres a modifier 
alpha=exp(-3.3); % Parametres a modifier 
gamma=exp(0.61); % Parametres a modifier 
% Pour trouver ces parametres, il faut faire les deux plot suivants et
% faire un linear fitting
% plot(1:1:size(imf1,1)-1,log(meanPeriod1(1,1:size(imf1,1)-1)),'*b');
% plot(1:1:size(imf2,1)-1,log(meanPeriod1(1,1:size(imf2,1)-1)),'+r');

hold on
plot(tttttt,alpha*(gamma.^tttttt),'g')

pM2=12.42 ;cpdM2=24/pM2;
pK1=23.93 ;cpdK1=24/pK1;
plot([tttttt(1) tttttt(end)],[1/cpdK1 1/cpdK1],'--k')
text( 1/cpdK1,1.3*(1/cpdK1),'$$K1$$','interpreter','latex','fontsize',10)
plot([tttttt(1) tttttt(end)],[1/cpdM2 1/cpdM2],'--k')
text( 1/cpdM2,1.3*(1/cpdM2),'$$M2$$','interpreter','latex','fontsize',10)

xlabel('Mode index','FontSize',10,'FontWeight','bold');
ylabel('Mean period (days)','FontSize',10,'FontWeight','bold');
legend('Temp1','Temp2','fitting','location','northWest')
% legend(seriesname(1),seriesname(2),'fitting')

print -djpeg -r600 IMFs_mean_periods_Comparisons.jpeg


%% Maintenant on choisit les IMFs par pairs pour faire les correlations


numberMode=1;   % changer cette ligne
numberMode1=5; % changer cette ligne
numberMode2=5; % changer cette ligne
for numberMode=1:min(size(imf1,1),size(imf2,1))
% Normalising the data 
                NormIMF1=(imf1(numberMode,:)-mean(imf1(numberMode,:)))/std(imf1(numberMode,:));
                NormIMF2=(imf2(numberMode,:)-mean(imf2(numberMode,:)))/std(imf2(numberMode,:));   
                [acor,lags] = xcorr( NormIMF1, NormIMF2,'coeff');
                [maxCorr ,I] = max(abs(acor));
                tau = lags(I); 
                dt=mean(diff(time_data(1,:)))*24*60; 
                leLagMinutes(numberMode)=tau *dt;
                leLagDays(numberMode)=tau*mean(diff(time_data(1,:)));
                laCorrelation(numberMode)=maxCorr;
end


%% Calcul de la contribution des IMFs  l energie totale --> Quelles sont les IMFs les plus energetiques ?

for i=1:size(imf1,1)-1
    variance_IMFs(i,1)=var(imf1(i,:));
    end
for i=1:size(imf2,1)
    variance_IMFs(i,2)=var(imf2(i,:));
end


somme_variance(1)=0;
somme_variance(2)=0;
for i=1:size(variance_IMFs,1)
    somme_variance(1)= somme_variance(1)+variance_IMFs(i,1);
    somme_variance(2)= somme_variance(2)+variance_IMFs(i,2);
end

for i=1:size(imf1,1)-1
   percentage_Of_Total(i,1)=100*variance_IMFs(i,1)/somme_variance(1);
  end
for i=1:size(imf2,1)-1
      percentage_Of_Total(i,2)=100*variance_IMFs(i,2)/somme_variance(2);
end

somme_percentage(1)=0;
somme_percentage(2)=0;
for i=1:size(percentage_Of_Total,1)
    somme_percentage(1)= somme_percentage(1)+ percentage_Of_Total(i,1);
    somme_percentage(2)= somme_percentage(2)+ percentage_Of_Total(i,2);
end

cumul_variance_IMFs(1,1)=var(imf1(1,:));
cumul_variance_IMFs(1,2)=var(imf2(1,:));
for i=2:size(imf1,1)
    cumul_variance_IMFs(i,1)=cumul_variance_IMFs(i-1,1)+var(imf1(i,:));
    cumul_variance_IMFs(i,2)=cumul_variance_IMFs(i-1,2)+var(imf2(i,:));
end

cumul_percentage(1)=percentage_Of_Total(1,1);
for i=2:size(percentage_Of_Total,1)
    cumul_percentage(i)=cumul_percentage(i-1)+percentage_Of_Total(i,1);
end

affichage=[meanPeriod(1:2,:)' percentage_Of_Total];
display('Mean periods of the IMFs (2 columns) & their contributions to the total energy (2 columns)');
disp(affichage);

