function p = betacdf(x,a,b,tail)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 3,'stats:betacdf:TooFewInputs');
validateattributes(x,{'single','double'},{'real'},'betacdf','x',1); %#ok<EMCA>
validateattributes(a,{'single','double'},{'real'},'betacdf','a',2); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'betacdf','b',3); %#ok<EMCA>
if nargin < 4
    upper = false;
else
    coder.internal.prefer_const(tail);
    upper = CheckForUpper(tail);
end
p = coder.internal.sxalloc([true,true,true],x,a,b);
for k = 1:numel(p)
    xk = eml_scalexp_subsref(x,k);
    ak = eml_scalexp_subsref(a,k);
    bk = eml_scalexp_subsref(b,k);
    if ak > 0 && bk > 0 && ~isinf(ak) && ~isinf(bk) && ~isnan(xk)
        if xk < 0
            p(k) = upper;
        elseif xk <= 1
            % BETAINC requires a case sensitive match to 'upper' or
            % 'lower'.
            if upper
                p(k) = real(betainc(xk,ak,bk,'upper'));
            else
                p(k) = real(betainc(xk,ak,bk,'lower'));
            end
        else
            p(k) = ~upper;
        end
    else
        p(k) = coder.internal.nan(class(p));
    end
end
