function x = betainv(p,a,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 3,'stats:betainv:TooFewInputs');
validateattributes(p,{'single','double'},{'real'},'betacdf','p',1); %#ok<EMCA>
validateattributes(a,{'single','double'},{'real'},'betacdf','a',2); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'betacdf','b',3); %#ok<EMCA>
nowarnings = true;
x = coder.internal.sxalloc([true,true,true],p,a,b);
for k = 1:numel(x)
    pk = eml_scalexp_subsref(p,k);
    ak = eml_scalexp_subsref(a,k);
    bk = eml_scalexp_subsref(b,k);
    if ak > 0 && bk > 0 && ~isinf(ak) && ~isinf(bk) && pk >= 0 && pk <= 1
        x(k) = real(betaincinv(pk,ak,bk));
        if nowarnings && ...
                abs(real(betainc(x(k),ak,bk)) - pk) > pk*sqrt(eps(class(x)))
            eml_warning('stats:betainv:NoConvergence', ...
                eml_flt2str(ak),eml_flt2str(bk),eml_flt2str(pk));
            nowarnings = false;
        end
    else
        x(k) = coder.internal.nan(class(x));
    end
end
