function y = betapdf(x,a,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 3,'stats:betapdf:TooFewInputs');
validateattributes(x,{'single','double'},{'real'},'betapdf','x',1); %#ok<EMCA>
validateattributes(a,{'single','double'},{'real'},'betapdf','a',2); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'betapdf','b',3); %#ok<EMCA>
y = coder.internal.sxalloc([true,true,true],x,a,b);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    ak = eml_scalexp_subsref(a,k);
    bk = eml_scalexp_subsref(b,k);
    if ak > 0 && bk > 0 && ~isnan(xk)
        if xk > 0 && xk < 1
            loga = (ak - 1)*log(xk);
            if xk < 0.1
                logb = (bk - 1)*log1p(-xk);
            else
                logb = (bk - 1)*log(1 - xk);
            end
            y(k) = exp(loga + logb - betaln(ak,bk));
        elseif ak == 1 && xk == 0
            y(k) = bk;
        elseif bk == 1 && xk == 1
            y(k) = ak;
        elseif (ak < 1 && xk == 0) || (bk < 1 && xk == 1)
            y(k) = coder.internal.inf(class(y));
        else
            y(k) = 0;
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
