function [m,v] = betastat(a,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:betastat:TooFewInputs');
validateattributes(a,{'single','double'},{'real'},'betastat','a',1); %#ok<EMCA>
validateattributes(b,{'single','double'},{'real'},'betastat','b',2); %#ok<EMCA>
m = coder.internal.sxalloc([true,true],a,b);
v = coder.nullcopy(m);
for k = 1:numel(m)
    ak = eml_scalexp_subsref(a,k);
    bk = eml_scalexp_subsref(b,k);
    if ak > 0 && bk > 0
        m(k) = ak/(ak + bk);
        v(k) = m(k)* bk/((ak + bk)*(ak + bk + 1));
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
