function x = binoinv(y,n,p) %#codegen
%MATLAB Code Generation Library Function

%   Copyright 1984-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 3,'stats:binoinv:TooFewInputs');
validateattributes(y,{'single','double'},{'real'},'binoinv','y',1); %#ok<EMCA>
validateattributes(n,{'numeric'},{'real'},'binoinv','n',2); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'binoinv','p',3); %#ok<EMCA>
x = coder.internal.sxalloc([true,isfloat(n),true],y,n,p);
for k = 1:numel(x)
    yk = eml_scalexp_subsref(y,k);
    nk = cast(eml_scalexp_subsref(n,k),class(x));
    pk = eml_scalexp_subsref(p,k);
    if nk >= 0 && pk >= 0 && pk <= 1 && yk >= 0 && yk <= 1 && floor(nk) == nk
        if yk == 1
            x(k) = nk;
        else
            xk = eml_scalar_eg(x);
            cumdist = xk;
            while true
                cumdist = cumdist + binopdf(xk,nk,pk);
                if cumdist > yk || xk >= nk
                    break
                end
                xk = xk + 1;
            end
            x(k) = xk;
        end
    else
        x(k) = coder.internal.nan(class(x));
    end
end
