function [m,v] = evstat(mu,sigma)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:evstat:TooFewInputs');
validateattributes(mu,{'single','double'},{'real'},'evstat','mu',1); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'evstat','sigma',2); %#ok<EMCA>
m = coder.internal.sxalloc([true,true],mu,sigma);
v = coder.nullcopy(m);
% -psi(1) is euler's constant
PSI1 = coder.internal.const(feval('psi',ones(class(sigma))));
for k = 1:numel(m)
    muk = eml_scalexp_subsref(mu,k);
    sigmak = eml_scalexp_subsref(sigma,k);
    if sigmak > 0
        m(k) = muk + PSI1*sigmak;
        sigmak = sigmak*pi;
        v(k) = sigmak*sigmak/6;
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
