function y = exppdf(x,mu)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:exppdf:TooFewInputs');
if nargin < 2
    mu = ones(class(x));
end
validateattributes(x,{'single','double'},{'real'},'exppdf','x',1); %#ok<EMCA>
validateattributes(mu,{'single','double'},{'real'},'exppdf','mu',2); %#ok<EMCA>
y = coder.internal.sxalloc([true,true],x,mu);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    muk = eml_scalexp_subsref(mu,k);
    if muk > 0 && ~isnan(xk)
        if xk < 0
            y(k) = 0;
        else
            y(k) = exp(-xk/muk)/muk;
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
