function r = frnd(v1,v2,varargin)
%MATLAB Code Generation Library Function

%   Limitations:
%   Only matches MATLAB if v1 and v2 are scalar and greater than zero.

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 2,'stats:frnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(v1,{'numeric'},{'real'},'frnd','v1',1); %#ok<EMCA>
validateattributes(v2,{'numeric'},{'real'},'frnd','v2',2); %#ok<EMCA>
r = coder.internal.sxalloc([isfloat(v1),isfloat(v2)],v1,v2,varargin{:});
for k = 1:numel(r)
    v1k = cast(eml_scalexp_subsref(v1,k),class(r));
    v2k = cast(eml_scalexp_subsref(v2,k),class(r));
    if v1k > 0 && v2k > 0
        num = randg(v1k/2)/v1k;
        den = randg(v2k/2)/v2k;
        r(k) = num/den;
    else
        r(k) = coder.internal.nan(class(r));
    end
end
