function [m,v] = gamstat(a,b)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin > 0,'stats:gamstat:TooFewInputs');
validateattributes(a,{'single','double'},{'real'},'gamstat','a',1); %#ok<EMCA>
if nargin < 2
    m = coder.nullcopy(a);
    v = coder.nullcopy(a);
    for k = 1:numel(a)
        if a(k) > 0
            m(k) = a(k);
            v(k) = a(k);
        else
            m(k) = coder.internal.nan(class(m));
            v(k) = coder.internal.nan(class(v));
        end
    end
else
    validateattributes(b,{'single','double'},{'real'},'gamstat','b',2); %#ok<EMCA>
    m = coder.internal.sxalloc([true,true],a,b);
    v = coder.nullcopy(m);
    for k = 1:numel(m)
        ak = eml_scalexp_subsref(a,k);
        bk = eml_scalexp_subsref(b,k);
        % Return NaN for out of range parameters.
        if ak > 0 && bk > 0
            m(k) = ak*bk;
            v(k) = m(k)*bk;
        else
            m(k) = coder.internal.nan(class(m));
            v(k) = coder.internal.nan(class(v));
        end
    end
end
