function y = geocdf(x,p,tail)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 2,'stats:geocdf:TooFewInputs');
validateattributes(x,{'numeric'},{'real'},'geocdf','x',1); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'geocdf','p',2); %#ok<EMCA>
if nargin < 3
    upper = false;
else
    coder.internal.prefer_const(tail);
    upper = CheckForUpper(tail);
end
y = coder.internal.sxalloc([isfloat(x),true],x,p);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    pk = eml_scalexp_subsref(p,k);
    if pk > 0 && pk <= 1 && ~isnan(xk)
        if xk < 0
            y(k) = upper;
        elseif upper
            if isfloat(xk)
                xkp1 = floor(xk) + 1;
            else
                xkp1 = cast(xk,class(y)) + 1;
            end
            y(k) = real(betainc(pk,1,xkp1,'upper'));
        else
            y(k) = 1 - (1 - pk)^(cast(floor(xk),class(y)) + 1);
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
