function x = geoinv(y,p)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:geoinv:TooFewInputs');
validateattributes(y,{'single','double'},{'real'},'geoinv','y',1); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'geoinv','p',2); %#ok<EMCA>
x = coder.internal.sxalloc([true,true],y,p);
for k = 1:numel(x)
    yk = eml_scalexp_subsref(y,k);
    pk = eml_scalexp_subsref(p,k);
    if pk > 0 && pk <= 1 && 0 <= yk && yk <= 1
        if yk == 0
            x(k) = 0;
        elseif yk == 1
            if pk < 1
                x(k) = coder.internal.inf(class(x));
            else
                x(k) = 0;
            end
        elseif pk < 1
            numer = log(1 - yk); % Could be log1p(-yk).
            peps = eps(class(p));
            if pk > peps
                denom = log(1 - pk); % Could be log1p(-pk).
            else
                denom = -pk; % log(1 - p) for small p
            end
            % log(1-y) and log(1-p) "really" should both be negative, and
            % the abs() here keeps the correct sign for their ratio when
            % roundoff (or y==0) makes one of them exactly zero.
            x(k) = ceil(abs(numer/denom) - 1 - sqrt(peps));
            if x(k) < 0
                x(k) = 0;
            end
        else % yk > 0 && yk < 1 && pk == 1
            x(k) = 0;
        end
    else
        x(k) = coder.internal.nan(class(y));
    end
end
