function x = gevinv(p,k,sigma,mu)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:gevinv:TooFewInputs');
if nargin < 2
    k = zeros(class(p));
end
if nargin < 3
    sigma = ones(class(p));
end
if nargin < 4
    mu = zeros(class(p));
end
validateattributes(p,{'single','double'},{'real'},'gevinv','p',1); %#ok<EMCA>
validateattributes(k,{'single','double'},{'real'},'gevinv','k',2); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'gevinv','sigma',3); %#ok<EMCA>
validateattributes(mu,{'single','double'},{'real'},'gevinv','mu',4); %#ok<EMCA>
x = coder.internal.sxalloc([true,true,true,true],p,k,sigma,mu);
for j = 1:numel(x)
    pj = eml_scalexp_subsref(p,j);
    kj = eml_scalexp_subsref(k,j);
    sigmaj = eml_scalexp_subsref(sigma,j);
    muj = eml_scalexp_subsref(mu,j);
    if sigmaj > 0 && 0 <= pj && pj <= 1
        if pj == 0
            if kj <= 0
                x(j) = -coder.internal.inf(class(x));
            else
                x(j) = muj - sigmaj/kj;
            end
        elseif pj == 1
            if kj < 0
                x(j) = muj - sigmaj/kj;
            else
                x(j) = coder.internal.inf(class(x));
            end
        else
            if abs(kj) < eps(class(x))
                x(j) = -log(-log(pj));
            else
                x(j) = expm1(-kj*log(-log(pj)))/kj; % ((-log(u))^(-k) - 1)/k
            end
            x(j) = sigmaj*x(j) + muj;
        end
    else
        x(j) = coder.internal.nan(class(x));
    end
end
