function x = gpinv(p,k,sigma,theta)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:gpinv:TooFewInputs');
if nargin < 2
    k = zeros(class(p));
end
if nargin < 3
    sigma = ones(class(p));
end
if nargin < 4
    theta = zeros(class(p));
end
validateattributes(p,{'single','double'},{'real'},'gpinv','p',1); %#ok<EMCA>
validateattributes(k,{'single','double'},{'real'},'gpinv','k',2); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'gpinv','sigma',3); %#ok<EMCA>
validateattributes(theta,{'single','double'},{'real'},'gpinv','theta',4); %#ok<EMCA>
x = coder.internal.sxalloc([true,true,true,true],p,k,sigma,theta);
for j = 1:numel(x)
    pj = eml_scalexp_subsref(p,j);
    kj = eml_scalexp_subsref(k,j);
    sigmaj = eml_scalexp_subsref(sigma,j);
    thetaj = eml_scalexp_subsref(theta,j);
    if sigmaj > 0 && 0 <= pj && pj <= 1
        if pj == 0
            x(j) = thetaj;
        elseif pj == 1
            if kj < 0
                x(j) = thetaj - sigmaj/kj;
            else
                x(j) = thetaj + coder.internal.inf(class(x));
            end
        elseif abs(kj) < eps(class(x))
            x(j) = thetaj - sigmaj*log1p(-pj);
        else
            x(j) = thetaj + sigmaj*expm1(-kj*log1p(-pj))/kj;
        end
    else
        x(j) = coder.internal.nan(class(x));
    end
end
