function y = gppdf(x,k,sigma,theta)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'MATLAB:minrhs');
if nargin < 2
    k = zeros(class(x));
end
if nargin < 3
    sigma = ones(class(x));
end
if nargin < 4
    theta = zeros(class(x));
end
validateattributes(x,{'single','double'},{'real'},'gppdf','x',1); %#ok<EMCA>
validateattributes(k,{'single','double'},{'real'},'gppdf','k',2); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'gppdf','sigma',3); %#ok<EMCA>
validateattributes(theta,{'single','double'},{'real'},'gppdf','theta',4); %#ok<EMCA>
y = coder.internal.sxalloc([true,true,true,true],x,k,sigma,theta);
for j = 1:numel(y)
    xj = eml_scalexp_subsref(x,j);
    kj = eml_scalexp_subsref(k,j);
    sigmaj = eml_scalexp_subsref(sigma,j);
    thetaj = eml_scalexp_subsref(theta,j);
    if sigmaj > 0
        zj = (xj - thetaj)/sigmaj;
        if zj < 0
            y(j) = 0;
        elseif abs(kj) < eps(class(y))
            y(j) = exp(-zj)/sigmaj;
        else
            tj = zj*kj;
            if tj <= -1 && kj < 0
                y(j) = 0;
            else
                y(j) = exp((-1 - 1/kj)*log1p(tj))/sigmaj;
            end
        end
    else
        y(j) = coder.internal.nan(class(y));
    end
end
