function [m,v] = gpstat(k,sigma,theta)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 2,'stats:gpstat:TooFewInputs');
validateattributes(k,{'single','double'},{'real'},'gpstat','k',1); %#ok<EMCA>
validateattributes(sigma,{'single','double'},{'real'},'gpstat','sigma',2); %#ok<EMCA>
USETHETA = nargin == 3 && ~(eml_is_const(isempty(theta)) && isempty(theta));
if USETHETA
    validateattributes(theta,{'single','double'},{'real'},'gpstat','theta',3); %#ok<EMCA>
    m = coder.internal.sxalloc([true,true,true],k,sigma,theta);
else
    m = coder.internal.sxalloc([true,true],k,sigma);
end
v = coder.nullcopy(m);
for j = 1:numel(m)
    kj = eml_scalexp_subsref(k,j);
    sigmaj = eml_scalexp_subsref(sigma,j);
    if sigmaj > 0 && ~isnan(kj)
        abskj = abs(kj);
        if abskj < eps(class(m))
            m(j) = sigmaj;
            v(j) = sigmaj*sigmaj;
        elseif kj >= 0.5
            if kj >= 1
                m(j) = coder.internal.inf(class(m));
            else
                m(j) = sigmaj/(1 - kj);
            end
            v(j) = coder.internal.inf(class(v));
        else
            m(j) = sigmaj/(1 - kj);
            v(j) = m(j)*m(j)/(1 - 2*kj);
        end
        if USETHETA
            thetaj = eml_scalexp_subsref(theta,j);
            m(j) = m(j) + thetaj;
        end
    else
        m(j) = coder.internal.nan(class(m));
        v(j) = coder.internal.nan(class(v));
    end
end
