function r = hygernd(m,k,n,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 3,'stats:hygernd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(m,{'numeric'},{'real'},'hygernd','m',1); %#ok<EMCA>
validateattributes(k,{'numeric'},{'real'},'hygernd','k',2); %#ok<EMCA>
validateattributes(n,{'numeric'},{'real'},'hygernd','n',3); %#ok<EMCA>
r = coder.internal.sxalloc([isfloat(m),isfloat(k),isfloat(n)],m,k,n,varargin{:});
for j = 1:numel(r)
    mj = eml_scalexp_subsref(m,j);
    kj = eml_scalexp_subsref(k,j);
    nj = eml_scalexp_subsref(n,j);
    if (nj <= mj && kj <= mj) && ...
            (0 < nj && floor(nj) == nj) && ...
            (0 < kj && floor(kj) == kj) && ...
            (0 < mj && floor(mj) == mj)
        r(j) = hygeinv(rand(class(r)),mj,kj,nj);
    else
        r(j) = coder.internal.nan(class(r));
    end
end
