function [mn,v] = hygestat(m,k,n)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 3,'stats:hygestat:TooFewInputs');
validateattributes(m,{'numeric'},{'real'},'hygestat','m',1); %#ok<EMCA>
validateattributes(k,{'numeric'},{'real'},'hygestat','k',2); %#ok<EMCA>
validateattributes(n,{'numeric'},{'real'},'hygestat','n',3); %#ok<EMCA>
mn = coder.internal.sxalloc([true,true,true],m,k,n);
v = coder.nullcopy(mn);
for j = 1:numel(mn)
    mj = eml_scalexp_subsref(m,j);
    kj = eml_scalexp_subsref(k,j);
    nj = eml_scalexp_subsref(n,j);
    if mj > 0 && floor(mj) == mj && ...
            kj >= 0 && kj <= mj && floor(kj) == kj && ...
            nj >= 0 && nj <= mj && floor(nj) == nj
        mn(j) = nj*kj/mj;
        v(j) = nj*kj*(mj - kj)*(mj - nj)/(mj*mj*(mj - 1));
    else
        mn(j) = coder.internal.nan(class(mn));
        v(j) = coder.internal.nan(class(v));
    end
end
