function x = icdf(name,p,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 2,'stats:icdf:TooFewInputs');
coder.internal.prefer_const(name);
coder.internal.assert(eml_is_const(name),'Coder:toolbox:InputMustBeConstant','NAME');
coder.internal.errorIf(~ischar(name),'stats:icdf:BadDistribution');
if nargin<2
    error(message('stats:icdf:TooFewInputs'));
end
if ~ischar(name)
    error(message('stats:icdf:BadDistribution'));
end
if nargin<5
    c = 0;
else
    c = varargin{3};
end
if nargin<4
    b = 0;
else
    b = varargin{2};
end
if nargin<3
    a = 0;
else
    a = varargin{1};
end
if     strcmpi(name,'beta'),
    x = betainv(p,a,b);
elseif strcmpi(name,'bino') || strcmpi(name,'Binomial'),
    x = binoinv(p,a,b);
elseif strcmpi(name,'chi2') || strcmpi(name,'Chisquare'),
    x = chi2inv(p,a);
elseif strcmpi(name,'exp') || strcmpi(name,'Exponential'),
    x = expinv(p,a);
elseif strcmpi(name,'ev') || strcmpi(name,'Extreme Value'),
    x = evinv(p,a,b);
elseif strcmpi(name,'f'),
    x = finv(p,a,b);
elseif strcmpi(name,'gam') || strcmpi(name,'Gamma'),
    x = gaminv(p,a,b);
elseif strcmpi(name,'gev') || strcmpi(name,'Generalized Extreme Value'),
    x = gevinv(p,a,b,c);
elseif strcmpi(name,'gp') || strcmpi(name,'Generalized Pareto'),
    x = gpinv(p,a,b,c);
elseif strcmpi(name,'geo') || strcmpi(name,'Geometric'),
    x = geoinv(p,a);
elseif strcmpi(name,'hyge') || strcmpi(name,'Hypergeometric'),
    x = hygeinv(p,a,b,c);
elseif strcmpi(name,'logn') || strcmpi(name,'Lognormal'),
    x = logninv(p,a,b);
elseif strcmpi(name,'nbin') || strcmpi(name,'Negative Binomial'),
    x = nbininv(p,a,b);
elseif strcmpi(name,'ncf') || strcmpi(name,'Noncentral F'),
    x = ncfinv(p,a,b,c);
elseif strcmpi(name,'nct') || strcmpi(name,'Noncentral T'),
    x = nctinv(p,a,b);
elseif strcmpi(name,'ncx2') || strcmpi(name,'Noncentral Chi-square'),
    coder.internal.errorIf(true,'Coder:toolbox:NotSupportedForCodegen', ...
        'Noncentral Chi-square');
    % x = ncx2inv(p,a,b);
elseif strcmpi(name,'norm') || strcmpi(name,'Normal'),
    x = norminv(p,a,b);
elseif strcmpi(name,'poiss') || strcmpi(name,'Poisson'),
    x = poissinv(p,a);
elseif strcmpi(name,'rayl') || strcmpi(name,'Rayleigh'),
    x = raylinv(p,a);
elseif strcmpi(name,'t'),
    x = tinv(p,a);
elseif strcmpi(name,'unid') || strcmpi(name,'Discrete Uniform'),
    x = unidinv(p,a);
elseif strcmpi(name,'unif')  || strcmpi(name,'Uniform'),
    x = unifinv(p,a,b);
elseif strcmpi(name,'weib') || strcmpi(name,'Weibull') || strcmpi(name,'wbl')
    if strcmpi(name,'weib') || strcmpi(name,'Weibull')
        eml_warning('stats:icdf:ChangedParameters');
    end
    x = wblinv(p,a,b);
else
    coder.internal.errorIf(true,'Coder:toolbox:NotSupportedForCodegen',name);
end
