function y = nbincdf(x,r,p,tail)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 3,'stats:nbincdf:TooFewInputs');
validateattributes(x,{'numeric'},{'real'},'nbincdf','x',1); %#ok<EMCA>
validateattributes(r,{'single','double'},{'real'},'nbincdf','r',2); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'nbincdf','p',3); %#ok<EMCA>
if nargin < 4
    upper = false;
else
    coder.internal.prefer_const(tail);
    upper = CheckForUpper(tail);
end
y = coder.internal.sxalloc([isfloat(x),true,true],x,r,p);
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    rk = eml_scalexp_subsref(r,k);
    pk = eml_scalexp_subsref(p,k);
    if rk > 0 && isfinite(rk) && 0 < pk && pk <= 1 && ~isnan(xk)
        if xk < 0
            y(k) = upper;
        elseif isinf(xk)
            y(k) = ~upper;
        else
            if upper
                y(k) = real(betainc(pk,rk,cast(xk,class(y))+1,'upper'));
            else
                s = zeros(class(y));
                m = floor(xk);
                for j = 0:m
                    s = s + nbinpdf(j,rk,pk);
                end
                y(k) = s;
                if y(k) > 1
                    y(k) = 1;
                end
            end
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
