function x = nbininv(y,r,p)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 3,'stats:nbininv:TooFewInputs');
validateattributes(y,{'single','double'},{'real'},'nbininv','y',1); %#ok<EMCA>
validateattributes(r,{'single','double'},{'real'},'nbininv','r',2); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'nbininv','p',3); %#ok<EMCA>
x = coder.internal.sxalloc([true,true,true],y,r,p);
for k = 1:numel(x)
    yk = eml_scalexp_subsref(y,k);
    rk = eml_scalexp_subsref(r,k);
    pk = eml_scalexp_subsref(p,k);
    if rk > 0 && isfinite(rk) && 0 < pk && pk <= 1 && 0 <= yk && yk <= 1
        if yk == 1
            x(k) = coder.internal.inf(class(x));
        elseif yk == 0
            x(k) = 0;
        else
            x(k) = 0;
            count = zeros(class(y));
            cumdist = nbinpdf(0,rk,pk);
            while cumdist < yk
                x(k) = x(k) + 1;
                count = count + 1;
                cumdist = cumdist + nbinpdf(count,rk,pk);
            end
        end
    else
        x(k) = coder.internal.nan(class(x));
    end
end
