function y = nbinpdf(x,r,p)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 3,'stats:nbinpdf:TooFewInputs');
validateattributes(x,{'numeric'},{'real'},'nbinpdf','x',1); %#ok<EMCA>
validateattributes(r,{'single','double'},{'real'},'nbinpdf','r',2); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'nbinpdf','p',3); %#ok<EMCA>
y = coder.internal.sxalloc([isfloat(x),true,true],x,r,p);
for k = 1:numel(y)
    xk = cast(eml_scalexp_subsref(x,k),class(y));
    rk = eml_scalexp_subsref(r,k);
    pk = eml_scalexp_subsref(p,k);
    if rk > 0 && isfinite(rk) && 0 < pk && pk <= 1 && ~isnan(xk)
        if xk >= 0 && isfinite(xk) && xk == floor(xk)
            if pk < 1
                lognk = gammaln(rk + xk) - gammaln(xk + 1) - gammaln(rk);
                y(k) = exp(lognk + rk*log(pk) + xk*log1p(-pk));
            else
                y(k) = (xk == 0);
            end
        else
            y(k) = 0;
        end 
    else
        y(k) = coder.internal.nan(class(y));
    end
end