function rnd = nbinrnd(r,p,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 2,'stats:nbinrnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(r,{'single','double'},{'real'},'nbinrnd','r',1); %#ok<EMCA>
validateattributes(p,{'single','double'},{'real'},'nbinrnd','p',2); %#ok<EMCA>
rnd = coder.internal.sxalloc([true,true],r,p,varargin{:});
for k = 1:numel(rnd)
    rk = eml_scalexp_subsref(r,k);
    pk = eml_scalexp_subsref(p,k);
    if 0 < rk && isfinite(rk) && 0 < pk && pk <= 1
        if rk ~= floor(rk) || rk > 50
            rnd(k) = poissrnd(randg(rk)*(1 - pk)/pk);
        elseif rk == 1
            rnd(k) = geornd(pk);
        else
            s = zeros(class(rnd));
            for j = 1:rk
                s = s + geornd(pk);
            end
            rnd(k) = s;
        end
    else
        rnd(k) = coder.internal.nan(class(rnd));
    end
end
