function r = nctrnd(v,delta,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 2,'stats:nctrnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(v,{'numeric'},{'real'},'nctrnd','v',1); %#ok<EMCA>
validateattributes(delta,{'single','double'},{'real'},'nctrnd','delta',2); %#ok<EMCA>
r = coder.internal.sxalloc([isfloat(v),true],v,delta,varargin{:});
for k = 1:numel(r)
    vk = cast(eml_scalexp_subsref(v,k),class(r));
    deltak = eml_scalexp_subsref(delta,k);
    if vk > 0
        if isinf(vk)
            r(k) = realmax(class(r));
        else
            num = randn(class(r)) + deltak;
            den = sqrt(2*randg(vk/2)/vk);
            r(k) = num/den;
        end
    else
        r(k) = coder.internal.nan(class(r));
    end
end
