function r = ncx2rnd(v,delta,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 2,'stats:ncx2rnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(v,{'numeric'},{'real'},'ncx2rnd','v',1); %#ok<EMCA>
validateattributes(delta,{'single','double'},{'real'},'ncx2rnd','delta',2); %#ok<EMCA>
r = coder.internal.sxalloc([isfloat(v),true],v,delta,varargin{:});
for k = 1:numel(r)
    vk = cast(eml_scalexp_subsref(v,k),class(r));
    deltak = eml_scalexp_subsref(delta,k);
    if vk >= 0 && deltak >= 0
        r(k) = 2*randg(poissrnd(deltak/2));
        r(k) = r(k) + 2*randg(vk/2);
    else
        r(k) = coder.internal.nan(class(r));
    end
end

