function [m,v]= ncx2stat(nu,delta)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:ncx2stat:TooFewInputs');
validateattributes(nu,{'numeric'},{'real'},'ncx2stat','nu',1); %#ok<EMCA>
validateattributes(delta,{'single','double'},{'real'},'ncx2stat','delta',2); %#ok<EMCA>
m = coder.internal.sxalloc([isfloat(nu),true],nu,delta);
v = coder.nullcopy(m);
for k = 1:numel(m)
    nuk = cast(eml_scalexp_subsref(nu,k),class(m));
    deltak = eml_scalexp_subsref(delta,k);
    if nuk > 0 && deltak >= 0
        m(k) = deltak + nuk;
        v(k) = 2*(nuk + 2*deltak);
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
