function x = poissinv(p,lambda)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:poissinv:TooFewInputs');
validateattributes(p,{'single','double'},{'real'},'poissinv','p',1); %#ok<EMCA>
validateattributes(lambda,{'single','double'},{'real'},'poissinv','lambda',2); %#ok<EMCA>
x = coder.internal.sxalloc([true,true],p,lambda);
for k = 1:numel(x)
    pk = eml_scalexp_subsref(p,k);
    lambdak = eml_scalexp_subsref(lambda,k);
    if 0 <= pk && pk <= 1 && lambdak >= 0
        if lambdak == 0 || pk == 0
            x(k) = 0;
        elseif pk == 1 % lambdak > 0 && pk == 1
            x(k) = coder.internal.inf(class(x));
        else % lambdak  > 0 && 0 < pk && pk < 1
            if lambdak > 10
                x1 = -sqrt(2)*erfcinv(2*pk);
                count = ceil(sqrt(lambdak)*x1 + lambdak);
                if count < 0
                    count(1) = 0;
                end
                y = gammainc(lambdak,count+1,'upper');
                if y < pk
                    % Check upward
                    while true
                        count = count + 1;
                        y = gammainc(lambdak,count+1,'upper');
                        if ~(y < pk)
                            break
                        end
                    end
                elseif y > pk
                    % Check downward
                    while true
                        y = gammainc(lambdak,count,'upper');
                        if y >= pk
                            count = count - 1;
                        else
                            break
                        end
                    end
                end
                % Get the final count
                x(k) = count;
            else
                count = zeros(class(x));
                while true
                    cumdist = gammainc(lambdak,count+1,'upper');
                    if cumdist < pk
                        count = count + 1;
                    else
                        break
                    end
                end
                x(k) = count;
            end
        end
    else
        x(k) = coder.internal.nan(class(x));
    end
end
