function y = poisspdf(x,lambda)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:poisspdf:TooFewInputs');
validateattributes(x,{'numeric'},{'real'},'poisspdf','x',1); %#ok<EMCA>
validateattributes(lambda,{'single','double'},{'real'},'poisspdf','lambda',2); %#ok<EMCA>
y = coder.internal.sxalloc([isfloat(x),true],x,lambda);
lnsr2pi = cast(log(sqrt(2*pi)),class(y));
for k = 1:numel(y)
    xk = eml_scalexp_subsref(x,k);
    lambdak = eml_scalexp_subsref(lambda,k);
    if lambdak >= 0 && ~isnan(xk)
        if lambdak == 0 && xk == 0
            y(k) = 1;
        elseif xk >= 0 && xk == floor(xk)
            if xk <= lambdak*realmin(class(y))
                y(k) = exp(-lambdak);
            elseif lambdak <= xk*realmin(class(y))
                xkf = cast(xk,class(y));
                y(k) = exp(-lambdak + xkf*log(lambdak) - gammaln(xkf+1));
            else
                xkf = cast(xk,class(y));
                y(k) = exp(-lnsr2pi - 0.5*log(xkf) - stirlerr(xkf) ...
                    - binodeviance(xkf,lambdak));
            end
        else
            y(k) = 0;
        end
    else
        y(k) = coder.internal.nan(class(y));
    end
end
