function y = evcdfz(x,upper)
%MATLAB Code Generation Private Function

%   When upper is true, y = exp(-exp(x)) avoiding overflow of exp(x).
%   When upper is false, y = -expm1(-exp(x)) avoiding overflow of exp(x).
%   The input x must be a scalar.

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.prefer_const(upper);
if upper
    ZMAX = coder.internal.const(log(log(2)-log(eps(realmin(class(x))))));
    if x > ZMAX
        y = zeros(class(x));
    else
        y = exp(-exp(x));
    end
else
    ZMAX = coder.internal.const(log(-log(eps(class(x))/4)));
    if x > ZMAX
        y = ones(class(x));
    else
        y = -expm1(-exp(x));
    end
end