function r = random(name,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 1,'MATLAB:minrhs');
coder.internal.prefer_const(name);
coder.internal.assert(eml_is_const(name),'Coder:toolbox:InputMustBeConstant','NAME');
coder.internal.errorIf(~ischar(name),'stats:random:IllegalDistribution');
if strncmpi('beta',name,length(name))
    r = betarnd(varargin{:});
elseif strncmpi('binomial',name,length(name))
    r = binornd(varargin{:});
elseif strncmpi('chi2',name,length(name)) || strncmpi('chi-square',name,length(name)) || strncmpi('chisquare',name,length(name))
    r = chi2rnd(varargin{:});
elseif strncmpi('ev',name,length(name)) || strncmpi('extreme value',name,length(name))
    r = evrnd(varargin{:});
elseif strncmpi('exponential',name,length(name))
    r = exprnd(varargin{:});
elseif strncmpi('f',name,length(name))
    r = frnd(varargin{:});
elseif strncmpi('gamma',name,length(name))
    r = gamrnd(varargin{:});
elseif strncmpi('gev',name,length(name)) || strncmpi('generalized extreme value',name,length(name))
    r = gevrnd(varargin{:});
elseif strncmpi('gp',name,length(name)) || strncmpi('generalized pareto',name,length(name))
    r = gprnd(varargin{:});
elseif strncmpi('geometric',name,length(name))
    r = geornd(varargin{:});
elseif strncmpi('hyge',name,length(name)) || strncmpi('hypergeometric',name,length(name))
    r = hygernd(varargin{:});
elseif strncmpi('lognormal',name,length(name))
    r = lognrnd(varargin{:});
elseif strncmpi('nbin',name,length(name)) || strncmpi('negative binomial',name,length(name))
    r = nbinrnd(varargin{:});
elseif strncmpi('ncf',name,length(name)) || strncmpi('noncentral f',name,length(name))
    r = ncfrnd(varargin{:});
elseif strncmpi('nct',name,length(name)) || strncmpi('noncentral t',name,length(name))
    r = nctrnd(varargin{:});
elseif strncmpi('ncx2',name,length(name)) || strncmpi('noncentral chi-square',name,length(name))
    r = ncx2rnd(varargin{:});
elseif strncmpi('normal',name,length(name))
    r = normrnd(varargin{:});
elseif strncmpi('poisson',name,length(name))
    r = poissrnd(varargin{:});
elseif strncmpi('rayleigh',name,length(name))
    r = raylrnd(varargin{:});
elseif strncmpi('t',name,length(name))
    r = trnd(varargin{:});
elseif strncmpi('unid',name,length(name)) || strncmpi('discrete uniform',name,length(name))
    r = unidrnd(varargin{:});
elseif strncmpi('uniform',name,length(name))
    r = unifrnd(varargin{:});
elseif strncmpi('wbl',name,length(name)) || strncmpi('weibull',name,length(name))
    if ~strcmp(name,'wbl')
        eml_warning('stats:random:ChangedParameters');
    end
    r = wblrnd(varargin{:});
else
    coder.internal.errorIf(true,'Coder:toolbox:NotSupportedForCodegen',name);
end
