function p = raylcdf(x,varargin)
%MATLAB Code Generation Library Function

%   Parameters: b,tail

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:raylcdf:TooFewInputs');
coder.internal.assert(nargin <= 3,'MATLAB:maxhrh');
validateattributes(x,{'single','double'},{'real'},'raylcdf','x',1); %#ok<EMCA>
[upper,nparms] = CheckForUpper(varargin{:});
if nparms < 1
    b = ones(class(x));
else
    b = varargin{1};
    validateattributes(b,{'single','double'},{'real'},'raylcdf','b',2); %#ok<EMCA>
end
p = coder.internal.sxalloc([true,true],x,b);
for k = 1:numel(p)
    xk = eml_scalexp_subsref(x,k);
    bk = eml_scalexp_subsref(b,k);
    if bk > 0 && ~isnan(xk)
        if xk < 0
            p(k) = upper;
        elseif upper
            p(k) = exp(-xk*xk/(2*(bk*bk)));
        else
            p(k) = -expm1(-xk*xk/(2*(bk*bk)));
        end
    else
        p(k) = coder.internal.nan(class(p));
    end
end
