function r = raylrnd(b,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 1,'stats:raylrnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(b,{'single','double'},{'real'},'raylrnd','b',1); %#ok<EMCA>
r = coder.internal.sxalloc(true,b,varargin{:});
for k = 1:numel(r)
    bk = eml_scalexp_subsref(b,k);
    if bk >= 0
        rn = randn(2,1,class(r));
        r(k) = hypot(rn(1),rn(2))*bk;
    else   
        r(k) = coder.internal.nan(class(r));
    end
end