function r = trnd(v,varargin)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.errorIf(nargin < 1,'stats:trnd:TooFewInputs');
coder.internal.prefer_const(varargin);
validateattributes(v,{'numeric'},{'real'},'trnd','v',1); %#ok<EMCA>
r = coder.internal.sxalloc(isfloat(v),v,varargin{:});
for k = 1:numel(r)
    vk = eml_scalexp_subsref(v,k);
    if vk > 0
        if isinf(vk)
            vf = realmax(class(r));
        else
            vf = cast(vk,class(r));
        end
        r(k) = randn(class(r));
        r(k) = r(k)*sqrt(vf/(2*randg(vf/2)));
    else
        r(k) = coder.internal.nan(class(r));
    end
end