function p = unidcdf(x,n,tail)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 2, ...
    'stats:unidcdf:TooFewInputs');
validateattributes(x,{'numeric'},{'real'},'unidcdf','x',1); %#ok<EMCA>
validateattributes(n,{'numeric'},{'real'},'unidcdf','n',2); %#ok<EMCA>
if nargin < 3
    upper = false;
else
    coder.internal.prefer_const(tail);
    upper = CheckForUpper(tail);
end
p = coder.internal.sxalloc([isfloat(x),isfloat(n)],x,n);
for k = 1:numel(p)
    xk = floor(eml_scalexp_subsref(x,k));
    nk = eml_scalexp_subsref(n,k);
    if nk >= 1 && floor(nk) == nk
        if xk >= nk
            p(k) = 1;
        elseif xk >= 1
            p(k) = cast(xk,class(p))/cast(nk,class(p));
        else
            p(k) = 0;
        end
        if upper
            p(k) = 1 - p(k);
        end
    else
        p(k) = coder.internal.nan(class(p));
    end
end
