function p = unifcdf(x,varargin)
%MATLAB Code Generation Library Function

%   Parameters: a,b,tail

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin >= 1,'stats:unifcdf:TooFewInputs');
coder.internal.assert(nargin <= 4,'MATLAB:maxrhs');
validateattributes(x,{'single','double'},{'real'},'unifcdf','x',1); %#ok<EMCA>
[upper,nparms] = CheckForUpper(varargin{:});
if nparms > 0
    coder.internal.assert(nparms == 2,'stats:unifcdf:TooFewInputs');
    a = varargin{1};
    b = varargin{2};
    validateattributes(a,{'single','double'},{'real'},'unifcdf','a',2); %#ok<EMCA>
    validateattributes(b,{'single','double'},{'real'},'unifcdf','b',3); %#ok<EMCA>
else
    a = zeros(class(x));
    b = ones(class(x));
end
p = coder.internal.sxalloc([true,true,true],x,a,b);
for k = 1:numel(p)
    xk = eml_scalexp_subsref(x,k);
    ak = eml_scalexp_subsref(a,k);
    bk = eml_scalexp_subsref(b,k);
    if ak < bk
        if xk >= bk
            p(k) = ~upper;
        elseif xk > ak && xk < bk
            if upper
                p(k) = (bk - xk)/(bk - ak);
            else
                p(k) = (xk - ak)/(bk - ak);
            end
        else
            p(k) = upper;
        end
    else
        p(k) = coder.internal.nan(class(p));
    end
end
