function [m,v] = wblstat(A,B)
%MATLAB Code Generation Library Function

%   Copyright 1993-2013 The MathWorks, Inc.
%#codegen

coder.internal.assert(nargin == 2,'stats:wblstat:TooFewInputs');
validateattributes(A,{'single','double'},{'real'},'wblstat','A',1); %#ok<EMCA>
validateattributes(B,{'single','double'},{'real'},'wblstat','B',2); %#ok<EMCA>
m = coder.internal.sxalloc([true,true],A,B);
v = coder.nullcopy(m);
for k = 1:numel(m)
    Ak = eml_scalexp_subsref(A,k);
    Bk = eml_scalexp_subsref(B,k);
    if Ak > 0 && Bk > 0
        gam1 = gamma(1 + 1/Bk);
        gam2 = gamma(1 + 2/Bk);
        gamdiff = gam2 - gam1*gam1;
        m(k) = Ak*gam1;
        % Force an Inf for very small B instead of a possible Inf-Inf==NaN.
        if gam2 == coder.internal.inf(class(gam2));
            v(k) = coder.internal.inf(class(v));
        elseif gamdiff > 0
            v(k) = Ak*Ak*gamdiff;
        else
            % large B (1e8, say)
            v(k) = 0;
        end
    else
        m(k) = coder.internal.nan(class(m));
        v(k) = coder.internal.nan(class(v));
    end
end
